#include <avr/io.h>         // 
#include <util/delay.h>

#define SPI_SS      PB2     // SS
#define SPI_MOSI    PB3     // MOSI
#define SPI_MISO    PB4     // MISO
#define SPI_SCK     PB5     // SCK
#define BUTTON_AP   PD4     //  A+
#define BUTTON_AM   PD5     //  A-
#define BUTTON_BP   PD6     //  B+
#define BUTTON_BM   PD7     //  B-

char di[5];

void spi(char cmd,char data)                //     8    SPI
{
        PORTB &= ~(1<<SPI_SS);              // SS  0
        SPDR = cmd;                         //   SPI 
        while(!(SPSR&(1<<SPIF)));           //  
        SPDR = data;                        //   SPI 
        while(!(SPSR&(1<<SPIF)));           //  
        PORTB |= (1<<SPI_SS);               // SS  1
}

int main()
{

   DDRB |= (1<<SPI_MOSI)|(1<<SPI_SCK)|(1<<SPI_SS);          // MOSI, SCK, SS  
   PORTD |= (1<<BUTTON_AP)|(1<<BUTTON_AM)|(1<<BUTTON_BP)|(1<<BUTTON_BM);   //   A+, A-, B+, B-  
   PORTB |=(1<<SPI_SS);                                     // SS  1
   SPCR |= (1<<SPE)|(1<<MSTR)|(1<<SPR1)|(1<<SPR0);          //  SPCR   SPI

   // MAX7221
    spi(0x0C,0x00);     // 
    spi(0x09,0xFF);     // 
    spi(0x0A,0x0A);     //  
    spi(0x0B,0x04);     //    0
    spi(0x0F,0x00);     //  
    spi(0x0C,0x01);     // 

int a=0;                        //    
int b=0;                        //    
unsigned char flag_button =0;   //    

    while(1){           // 

        di[2]=a%10;                                                 //  
        if(a<10)di[1]=15;else di[1]=((a-di[2])/10)%10;              // a   
        if(a<100)di[0]=15;else di[0]=((a-di[1]*10-di[2])/100)%10;   //     
            spi(1,di[0]);           // 
            spi(2,di[1]);           // a 
            spi(3,di[2]);           //  

        di[4]=b%10;                                     //  
        if(b<10)di[3]=15;else di[3]=((b-di[4])/10)%10;  // a    
            spi(4,di[3]);           //   b 
            spi(5,di[4]);           //  

       if(!(PIND & (1<<BUTTON_AP)))flag_button|=(1<<3);     //  
       if(!(PIND & (1<<BUTTON_AM)))flag_button|=(1<<2);     //   
       if(!(PIND & (1<<BUTTON_BP)))flag_button|=(1<<1);     // flag_button
       if(!(PIND & (1<<BUTTON_BM)))flag_button|=(1<<0);
       _delay_ms(100);                   //     
       if(!(PIND & (1<<BUTTON_AP))&&(flag_button&(1<<3)))a++;   //  
       if(!(PIND & (1<<BUTTON_AM))&&(flag_button&(1<<2)))a--;   //   
       if(!(PIND & (1<<BUTTON_BP))&&(flag_button&(1<<1)))b++;   // flag_button
       if(!(PIND & (1<<BUTTON_BM))&&(flag_button&(1<<0)))b--;
       flag_button=0;               //   

       if(a>999)a=999;      //     a
       if(a<0)a=0;          //     a
       if(b>99)b=99;        //     b
       if(b<0)b=0;          //     b
    }
    return 0;
}
